/* 
 * sun_rpc_internal.h
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#define RPCRPLYLEN	100  
#define RPC_WAIT        50000
#define RPC_TTOUT       200000
#define XDRBUFSIZE      1024 
#define RPCMAXLEN       1024 
#define CUR_RPC_VERS	2
#define RPC_VERS_LOW 	2
#define RPC_VERS_HIGH	2

typedef struct sunrpcextid {
      SUNRPCaddr   server;
      UDPaddr   client;
      enum msg_type direction;
} SUNRPC_EXTID;

typedef struct {
      enum msg_type  direction; 
      unsigned long xid;
      SUNRPCaddr   server;
      UDPaddr   client;
      Bind   port_bind;
      struct  timeval tout;
      struct  timeval wait;
      struct rpc_msg *rpchdr;    
      struct rpc_msg *errhdr;    
      XObj     down_s;
      Msg       rtstmsg;
      Msg       ctstmsg;                
      Semaphore reply_sem;
      int       tries;
      int       old_tries;
      struct opaque_auth cred;
      struct opaque_auth verf;
      struct rpc_err error;
} SUNRPC_STATE;

#define TIMEVALLEN sizeof(struct timeval)

/* Values for "who" in an open_state */

#define RPCCLIENT       1
#define RPCSERVER       2



